SystemOrganization addCategory: #'XLS-Exporter-Formatting'!
SystemOrganization addCategory: #'XLS-Exporter'!

Object subclass: #Average
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XLS-Exporter'!

!Average methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 7/12/2012 00:18'!
formula: aFormula worksheet: aWorksheet 
	"comment stating purpose of message"

	| alpha x size count column start end numelements colid size2 rowid sum c cell val avg |
	alpha:= 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'.
	x :=('')asString .
	size:= aFormula  size.
	count:=1.
	[count<(size+1)] whileTrue: [
		(aFormula at:count)asString  = ':'
		ifTrue: [
			column:= (aFormula at: (count+1)) asString .
			start:= (aFormula at: (count -1)) asInteger -47 .
			end := (aFormula at: (count+2))asInteger -48.
			start to: end do: [:n|
				x:= x,','. 
				x:= x,column.
				x:= x, (n asString) .
				].			
			count:=count+2.
			]
		ifFalse: [
			(aFormula at:count)asString  = ' '
			ifFalse: [x:= x, (aFormula at: count) asString]].
		count := count+1.
	].
	sum:=0.
	numelements:=0.
	size2:= x size.
	colid:=1.
	[(alpha at:colid)asString = (aFormula at:1)asString  ] whileFalse:  [
		colid:= colid+1.
	].
	val:=10.
	rowid:=0.
	c:=1.
	[c<(size2 +1)]
	whileTrue: [
		(x at: c ) asString = ',' ifTrue: [
			rowid:= val.
			cell:=(aWorksheet cellAt: rowid at: colid).
			sum:= sum + cell value.
			numelements:= numelements+1.]
		
		ifFalse:[
			(x at:c)asString = (aFormula at:1)asString 
			ifTrue: [ val:=0.]
			ifFalse: [
				val:= val*10.
				val := val+  ((x at:c) asInteger -48).
				].
			].		
		c = size2 ifTrue: [rowid:= val.
			cell:=(aWorksheet cellAt: rowid at: colid).
			sum:= sum + cell value.
			numelements:= numelements+1.].
		
		c:=c+1.
		].

	^(sum/numelements )asFloat.
	! !

!Average methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 7/11/2012 22:02'!
initialize
	"comment stating purpose of message"

	| temporary variable names |
	super initialize .! !

Object subclass: #Font
	instanceVariableNames: 'statements height italic struck_out outline shadow colour_index bold us_weight escapement underline family charset name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XLS-Exporter-Formatting'!

!Font methodsFor: 'initialize-release' stamp: 'SauravBhattacharya 7/7/2012 02:02'!
initialize
	"comment stating purpose of message"

	| temporary variable names |
	  super initialize .
	  height:= '0x00C8' .
        italic:= False.
        struck_out:= False.
        outline:= False.
        shadow:= False.
        colour_index:= '0x7FFF'.
        bold:= False.
        us_weight:= '0x0190' .
        escapement:= '0x00'.
        underline:= '0x00'.
        family:=  '0x00'.
        charset:= '0x01'.
        name:= 'Arial'.! !

Object subclass: #Formula
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XLS-Exporter'!

!Formula methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 7/12/2012 00:22'!
formula: aFormula worksheet: aWorksheet 
	"comment stating purpose of message"

	| temporary variable names size val s SYM|
	size := aFormula size.
	val := 'null'.
	
	SYM:= (aFormula copyFrom: 2 to: 4).
	SYM = 'SUM'
	ifTrue: [ s:= Sum new.
		val := s formula: (aFormula copyFrom: 6 to: size-1) worksheet: aWorksheet. 
		val:= 'SUM=', val asString .]
	ifFalse: [
		SYM = 'AVG'
		ifTrue: [ s:= Average new.
			val := s formula: (aFormula copyFrom: 6 to: size-1) worksheet: aWorksheet ].
			val:= 'AVG=', val asString  ].
	^val.! !

!Formula methodsFor: 'initialize-release' stamp: 'SauravBhattacharya 7/11/2012 16:50'!
initialize
	"comment stating purpose of message"

	| temporary variable names |
	super initialize.! !

Object subclass: #Sum
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XLS-Exporter'!

!Sum methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 7/11/2012 21:59'!
formula: aFormula worksheet: aWorksheet 
	"comment stating purpose of message"

	| alpha x size count column start end numelements colid size2 rowid sum c cell val |
	alpha:= 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'.
	x :=('')asString .
	size:= aFormula  size.
	count:=1.
	[count<(size+1)] whileTrue: [
		(aFormula at:count)asString  = ':'
		ifTrue: [
			column:= (aFormula at: (count+1)) asString .
			start:= (aFormula at: (count -1)) asInteger -47 .
			end := (aFormula at: (count+2))asInteger -48.
			start to: end do: [:n|
				x:= x,','. 
				x:= x,column.
				x:= x, (n asString) .
				].			
			count:=count+2.
			]
		ifFalse: [
			(aFormula at:count)asString  = ' '
			ifFalse: [x:= x, (aFormula at: count) asString]].
		count := count+1.
	].
	sum:=0.
	numelements:=1.
	size2:= x size.
	colid:=1.
	[(alpha at:colid)asString = (aFormula at:1)asString  ] whileFalse:  [
		colid:= colid+1.
	].
	val:=10.
	rowid:=0.
	c:=1.
	[c<(size2 +1)]
	whileTrue: [
		(x at: c ) asString = ',' ifTrue: [
			rowid:= val.
			cell:=(aWorksheet cellAt: rowid at: colid).
			sum:= sum + cell value.
			numelements:= numelements+1.]
		
		ifFalse:[
			(x at:c)asString = (aFormula at:1)asString 
			ifTrue: [ val:=0.]
			ifFalse: [
				val:= val*10.
				val := val+  ((x at:c) asInteger -48).
				].
			].		
		c = size2 ifTrue: [rowid:= val.
			cell:=(aWorksheet cellAt: rowid at: colid).
			sum:= sum + cell value.
			numelements:= numelements+1.].
		
		c:=c+1.
		].

"	^(x at:11)asString ."
	^sum.
	! !

!Sum methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 7/11/2012 16:54'!
initialize 
	"comment stating purpose of message"

	| temporary variable names |
	super initialize .! !

Object subclass: #Workbook
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XLS-Exporter'!

Object subclass: #XLSExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XLS-Exporter'!

!XLSExporter methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 7/11/2012 18:15'!
generateXLSAt: aPath filename: aName spreadsheet: aSpreadsheet
	"comment stating purpose of message"

	| currFilePath filePath stream numOfWorksheets rows cols cell prefix f |
	numOfWorksheets := aSpreadsheet worksheetNum.
	
	1 to: numOfWorksheets do: [:currwb | 	
		prefix:=(currwb ) asString .	
		filePath := aPath,prefix,aName .
		stream := StandardFileStream fileNamed: filePath .
		"stream nextPutAll: (aSpreadsheet worksheetAt: currwb) title."
		"stream nextPutAll: String cr."
		rows := (aSpreadsheet worksheetAt: currwb ) maxNumOfRows.
		cols := (aSpreadsheet worksheetAt: currwb ) maxNumOfColumns.
		1 to:rows do: [:row |
			
			1 to:cols do: [:col | 	
				cell:= ((aSpreadsheet worksheetAt: currwb) cellAt: row at: col).
				cell type = 'formula'
				ifTrue:[ 
					f:= Formula new.
					cell value:(f formula: (cell formula) worksheet: (aSpreadsheet worksheetAt: currwb) ).
					stream nextPutAll: (cell value)asString .
					]
				ifFalse: [stream nextPutAll: (cell value)asString .].
				stream nextPutAll: String tab.
			].
		stream nextPutAll: String cr.
		].	
		stream nextPutAll: String cr.
		stream cr.
		stream close.	
	].
	! !
